% Plotausgaben zur Simulation der Regelung des TR-Roboters
% (Zweigelenkregelung)
% W. Weber,  Oktober 2012
% Änderungen September 2023

anzschritte=size(qsoll);
anz=anzschritte(1,2);

Zeitreihe=(0:1:(anz-1))*T_Ipo;
Zeitreihe=Zeitreihe';

close all;  % alle Figures werden gelöscht


%plot(psoll(1,:),psoll(3,:),'r:')
plot(psoll(1,:),psoll(3,:),'k:','LineWidth',1.5)
hold on
plot(pist(1,:),pist(3,:),'k-','LineWidth',1.5)
xlabel('x0 in m')
ylabel('z0 in m')
title('kart. Bahn, gestrichelt:Soll, durchgezogen: Ist')
grid

figure
plot(Zeitreihe,v_bahn_soll(1,:), 'r:',Zeitreihe,v_bahn_ist(1,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('dx0/dt in m/sec')
title('Verlauf Geschw. x0-Achse in m/sec,gestrichelt:Soll, durchgezogen: Ist')
grid

figure
plot(Zeitreihe,v_bahn_soll(3,:), 'r:',Zeitreihe,v_bahn_ist(3,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('dz0/dt in m/sec')
title('Verlauf Geschw. z0-Achse in m/sec, gestrichelt:Soll, durchgezogen: Ist')
grid

figure
plot(Zeitreihe,qsoll(1,:),'r:', Zeitreihe,qist(1,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('q1 in m')
title('Verlauf Gelenkkoordinate 1 in m, gestrichelt: Soll, durchgezogen: Ist')
grid

figure
plot(Zeitreihe,qsoll(2,:),'r:', Zeitreihe,qist(2,:),'k-','LineWidth',1.5 )
xlabel('Zeit in s')
ylabel('q2 in rad')
title('Verlauf Gelenkkoordinate 2 in rad, gestrichelt: Soll, durchgezogen: Ist')
grid

figure
plot(Zeitreihe,qpsoll(1,:),'r:', Zeitreihe,qpist(1,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('dq1/dt in m/sec')
title('Verlauf Gelenkgeschw. 1 in m/sec, rot gestrichelt:Soll, schwarz durchgez.: Ist')

figure
plot(Zeitreihe,qpsoll(2,:),'r:', Zeitreihe,qpist(2,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('dq2/dt in rad/sec')
title('Verlauf Gelenkgeschw. 2 in rad/sec  rot gestrichelt:Soll, schwarz durchgez.: Ist')
grid

figure
plot(Zeitreihe,US(1,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('Stellwert US Gelenk 1, z.B. in V')
title('Verlauf Stellwert US Gelenk 1')
grid

figure
plot(Zeitreihe,US(2,:),'k-','LineWidth',1.5)
xlabel('Zeit in s')
ylabel('Stellwert US Gelenk 2, z.B. in V')
title('Verlauf Stellwert US Gelenk 2')
grid
