function [p,v_bahn,b_bahn,v_corr,b_corr,se,tb,tv,te,korr_msg] = Lin_bahn3D(pa,pb,v,b,T_Ipo,Ipoart)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Linearinterpolation im  einer Ebene z.B. fuer 2-Gelenkplanarroboter Bild
% 3.5 oder Kreuztisch oder TR-Roboter
% Allgemein kann aber die Interpolation zwischen zwischen zwei beliebigen Vektoren pa und pb 
% durchgeführt werden.
% Unterprogramme: 
% 	Rampenprofil 	[s,v_vek,acc_vek]= rampe(se,tb,tv,te,v_corr,b_corr,T_Ipo) ;  
%	
%
% % Letzte Aenderung. 30.10.12 von W. Weber
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b_corr = [];
se = [norm(pb(1:3,1)-pa(1:3,1))]; % Berechnung der Bahnlaenge
   
      if Ipoart==1   % Rampenprofil
         if T_Ipo^2*b > se
            b_corr=se/T_Ipo^2;
            v_corr=b_corr*T_Ipo;
            korr_msg=['Geschwindigkeit und Beschleunigung musste korrigiert werden (T_Ipo^2*b > se) '];
            msgbox('Geschwindigkeit und Beschleunigung musste korrigiert werden (T_Ipo^2*b > se) ');
            tb=T_Ipo;
            te=2*tb;
            tv=tb;
         else
            % hier: Beschleunigung muss nicht korrigiert werden wegen minimaler Fahrstrecke        
            tb=v/b;
            tv=se/v;
            te=tb+se/v;
            v_corr=v;
            b_corr=b;
         
                	if te < 2*tb		% 
				 		   korr_msg=['Geschwindigkeit musste korrigiert werden (te<2*tb) '];
                           msgbox('Geschwindigkeit musste korrigiert werden (te<2*tb) ');
                           v_corr =  sqrt(se*b) ;	
  				 		   % Anpassung an die Interpolationsschrittweite 
                     tb=v_corr/b;
                     tv=tb; 
                     te=tb+tv;
                    else
                     korr_msg=''; 
                    end	
                  
            [s,v_vek,acc_vek]= rampe(se,tb,tv,te,v_corr,b_corr,T_Ipo) ;  % Aufruf Berechnung von s
      	end
      end
      
      
      
      

		z = size(s,2);					                    % z holt sich die Anzahl der Abtastpunkte 
                                                             % aus der
                                                             % Matrix s
		for i=1:z

  			if abs(se) <= 0,             		                    % se(1)==0,-> keine Bahnnderung
  
    		   p(:,i) = pa(1:3,1);		                            % Vektor p bleibt immer der selbe
               v_bahn(:,i)=[0;0;0];
               b_bahn(:,i)=[0;0;0];                                  % keine Bewegung 
                  
 	      	else
  
    			p(:,i) = pa(1:3,1) + (pb(1:3,1)-pa(1:3,1)).*(s(1,i)/se(1));    % Berechnung der Zwischenstellungen der Strecke
               v_bahn(:,i) = (pb(1:3,1)-pa(1:3,1)).*(v_vek(1,i)/se(1));    % Berechnung der Zwischenstellungen d
               b_bahn(:,i) = (pb(1:3,1)-pa(1:3,1)).*(acc_vek(1,i)/se(1)); 
               %z_time=[z_time z*T_Ipo]
  			end; % fr Bahnberechnung Bahnpunkt-Linearbewegung
     
		end; % fr for Schleife Berechnung p 
      



      

