function [M_Stern,b_Stern,M_Stern_invers, qpp]=M_Stern_b_Stern(q,qp,US)
% Teilprogramm zu Simulation_Zweigelenkregelung 
% Berechnung von M*(q), b*(q,qp) inv(M*) und qpp mit Bercksichtigung der Haftreibung, US muss bekannt sein   
% W. Weber, Juli 2011, Oktober 2012, August 2023 (mit Lastmasse)
global mL h1 h2 g Ixx_1 Iyy_1 Izz_1 s1 p1 m1 MRG0 FD1 JA1 C1 MR01 FM1 KMI1 
global Ixx_2 Iyy_2 Izz_2 s2 p2 m2 FR02 FD2 JA2 C2 MR02 FM2 KMI2 
global u1 u2 SG TG JA KM FD FM MR0 Haft_G0 C eps_qp T_Ipo

q1=q(1,1);
q2=q(2,1); 
q1p=qp(1,1);
q2p=qp(2,1); 

l2=p2(1,1);
lsp2=p2(1,1)+s2(1,1);
   M11=m1+m2+mL;
   M22=(m2*lsp2^2+mL*l2^2)+Izz_2;
   M12=(m2*lsp2+mL*l2)*cos(q2);
   M21=M12;
   M=[M11 M12; M21 M22];
   b1_oHaft=-(m2*lsp2+mL*l2)*sin(q2)*q2p^2+FD1*q1p;
   b2_oHaft=(m2*lsp2+mL*l2)*g*sin(q2)+FD2*q2p;
  
   b_oHaft=[b1_oHaft;b2_oHaft];
   M_Stern=inv(KM)*(inv(SG)*M+JA*inv(TG));
   b_Stern_oHaft=inv(KM)*(inv(SG)*b_oHaft+FM*inv(TG)*qp);
   
   % b_stern wegen Haftreibung korrigieren
   %Betrag  des Haftreibungsmomentes bzw. Haftreibungskraft
   Haft_Stern=inv(KM)*MR0+inv(KM)*inv(SG)*Haft_G0;
   
    
   
   %+++++++++++++++++++++++++++++++++++++++++
   RHa=[0;0];% Startwerte fr Haftreibungsmoment bzw. Haftreibungskraft
   for loop=1:2
      if (qp(loop)>eps_qp)
        RHa(loop)=Haft_Stern(loop);
		elseif (qp(loop)<0 & qp(loop) < -eps_qp);
      	RHa(loop)=-Haft_Stern(loop);
      else
        RHa(loop)=min(abs(US(loop)-b_Stern_oHaft(loop)), Haft_Stern(loop));  % hier noch kein Vorzeichen
        RHa(loop)=-sign(US(loop)-b_Stern_oHaft(loop)).* RHa(loop);
      end;
   end % end fr for Schleife
   
   b_Stern=b_Stern_oHaft+RHa;   
   
     %++++++++++++++++++++++++++++++++++++++++
   % Berechnung von M_Stern_invers = M_Stern**-1
   M_Stern_invers = inv(M_Stern); 
   % Berechnung von qpp
   qpp=M_Stern_invers *(US-b_Stern);
   
   
   