function [qist_neu, qpist_neu]=RK2_eig(US,qist_akt,qpist_akt);
%                        RV6-gelenk-roboter
%
% Lsung der DGL mit einem selbst geschriebenen Runge-Kutta-2-Verfahren
%-----------------------------------------------------------
% Mrz 2011 von W. Weber,
% letzte nderungen August 2023


   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % 1. Berechnungen zum Zeitpunkt k: qdd als funktion von q, qd
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
global mL h1 h2 g Ixx_1 Iyy_1 Izz_1 s1 p1 m1 MRG0 FD1 JA1 C1 MR01 FM1 KMI1 
global Ixx_2 Iyy_2 Izz_2 s2 p2 m2 FR02 FD2 JA2 C2 MR02 FM2 KMI2 
global u1 u2 SG TG JA KM FD FM MR0 Haft_G0 C eps_qp T_Ipo

   delT=T_Ipo;    % Zeitinkrement zur Lsung der DGL
   
   % Berechnung der Matrix M_Stern und des Vektors b_Stern (mit eventueller
   % Lastmasse)
   
   [M_Stern,b_Stern,M_Stern_invers, qpp]=M_Stern_b_Stern_TR(qist_akt,qpist_akt,US);
   %M_Stern_b_Stern; % Berechnung des aktuellen M* , b*, inv(M*) und qpp  
   
   
 
  	% Berechnung der Gelenkbeschleunigungen im Zeitpunkt k (tk)
  	%qalt=q;            % Winkelwerte zum Zeitpunkt k
  	%palt=qp;          % Winkelgeschwindigkeiten zum Zeitpunkt k

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%	  2. Berechnen von Zwischenwerten (im Zustandsraum x(k+0.5)), abhngig von qdd, q=qalt, qd=qdalt   
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    qzw=qist_akt+(delT/2)*qpist_akt;
   
    qpzw=qpist_akt+(delT/2)*qpp;  % Zustandsvektor [qzw; qdzw] im Zwischenpunkt ist bekannt !

      
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%  3. Berechnen der Werte am Ende des Intervalls (im Zustandsraum x(k+1)), abhngig von qpp, q=qzw, qp=qdzw   
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   qist_neu=qist_akt+delT*qpzw;  % Vektor der Winkel zum Zeitpunkt k+1
   
   [M_Stern,b_Stern,M_Stern_invers, qppzw]=M_Stern_b_Stern_TR(qzw,qpzw,US);
   %Berechnung_M_Stern_b_Stern; % Berechnung des aktuellen M* , b* und inv(M*)  
   %qppzw=M_Stern_invers*(US-b_Stern);	% Berechnung der Gelenkbeschleunigungen   
    
   qpist_neu=qpist_akt+delT*qppzw;  % Winkelgeschw. zum Zeitpunkt k+1
                        %nun ist der zustandsvektor zum Zeitpunkt k+1 vollstndig berechnet

