function [q_vek,qp_vek] = RTRAFO_TR_ges(p_vek,p_punkt_vek,a2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   RTRAFO fr den TR-Roboter (siehe ausfhrliches Beispiel zu 
%   Master mechatronik HFB, Lehrveranst. Motion Control (mc) (mc
%   oder BSR04 
%   W. Weber: Oktober 2012
%   nderung; 23.08.2021
%
%   Eingabe: p_vek=[px;py] : Gelenkkoordinaten p_vek(2,n) n: zeitl. Serie von p  
%   Eingabe: p_punkt_vek:  kart. Geschwindigkeitsvektor , n: zeitl. Serie von p_punkt 
%   
%                
%      
%
%   Die Transformation basiert auf folgenden D.-H-Parametern
%   d1=q1, d2=0, a1=0, a2=l2=0.5, alpha1=pi/2, alpha2=0;
%
%   
%   letzte nderung 02.09.23, W. Weber 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
global T_Ipo
eps_sing=0.0001;

%px=p_v(1);
%py=p_vek(2);

%q1=atan2(-px,py);
%q2=norm(p_vek)

q_vek(2,:)=pi/2+asin(p_vek(1,:)/a2);
%q_vek(2,:)=3*pi/2-asin(p_vek(1,:)/a2);
q_vek(1,:)=p_vek(3,:)-a2*cos(q_vek(2,:)-pi/2);

% Zur Berechnung von qp_vek wird die Jacobimatrix verwendet
% [xo_p; z0_p]=J*[q1_p;q2_p]
%J=[0 a2*cos(q2-90); 1 -a2*sin(q2-909];
% inv(J)= [tan(q2-90) 1 ; 1/(a2*cos(q2-90) 0]

dm=size(p_vek);
anz_schritte=dm(1,2);
qp_vek(1,1)=0;
qp_vek(2,1)=0;

for i1=2:anz_schritte
       if abs(cos(q_vek(2,i1)-pi/2)) < eps_sing
      %  if  abs(q_vek(2,i1)-pi) < eps_sing
        disp(' Nhe Singularitt')
        disp(i1)
     %  disp(i1)
        %
     %   qp_vek(1,i1)=tan(q_vek(2,i1)-pi/2) * p_punkt_vek(1,i1) + p_punkt_vek(3,i1);
     %   qp_vek(1,i1)= p_punkt_vek(3,i1);
     %   qp_vek(2,i1)=0;
     qp_vek(1,i1)=(q_vek(1,i1)-q_vek(1,i1-1))/T_Ipo;
     qp_vek(2,i1)=(q_vek(2,i1)-q_vek(2,i1-1))/T_Ipo;
    else
        %disp('keine singulre Stelle')
        qp_vek(1,i1)=tan(q_vek(2,i1)-pi/2) * p_punkt_vek(1,i1) + p_punkt_vek(3,i1);
        qp_vek(2,i1)=1/(a2*cos(q_vek(2,i1)-pi/2))* p_punkt_vek(1,i1);
        %qp_vek(2,i1)=1/(a2*cos(q_vek(2,i1)-pi/2))* p_punkt_vek(1,i1);       % diese Lsung bis 1.9.23
        %qp_vek(1,i1)=sin(q_vek(2,i1)-pi/2) * a2*qp_vek(2,i1) + p_punkt_vek(3,i1); % diese Lsung bis 1.2.23
       
        
    end
end

%test_singulaer(1,:)=abs(cos(q_vek(2,:)-pi/2))
%abs(cos(q_vek(2,:)-pi/2)) > eps_sing 
%qp_vek(1,:)=tan(q_vek(2,:)-pi/2) .* p_punkt_vek(1,:) + p_punkt_vek(3,:);
%qp_vek(2,:)=1./(a2*cos(q_vek(2,:)-pi/2)).* p_punkt_vek(1,:);

    

