% Hauptprogramm/Startprogramm Zweigelenkregelung TR
% W. Weber, September 2023

global mL h1 h2 g Ixx_1 Iyy_1 I_1 s1 p1 m1 MRG0 FD1 JA1 C1 MR01 FM1 KMI1 
global Ixx_2 Iyy_2 Izz_2 s2 p2 m2 FR02 FD2 JA2 C2 MR02 FM2 KMI2 
global u1 u2 SG TG JA KM FD FM MR0 Haft_G0 C eps_qp T_Ipo

psoll=[]; v_bahn_soll=[];  qsoll=[]; qpsoll=[];   % Initialisierungen der Hauptfelder, unbed. notwendig

disp('   ')
disp('Simulation der Bewegungsregelung des TR-Zweigelenkroboters')

disp('W. Weber, Stand August 2023 ')
disp('   ')

T_Ipo=0.002 % Rechenschrittweite=T_IPO wird gleichzeitig als Abtastzeit genommen, sozusagen quasikont. Verhalten 
% Streckenparameter mit Angabe einer Lastmasse

Streckenparameter_TR_MC0203;

% minimale und maximale Gelenkkoordinaten 
q1_min=0; q1_max=1.5;
q2_min=pi/2; q2_max=1.5*pi;

q_min=[q1_min; q2_min];
q_max=[q1_max; q2_max];

% Stellbegrenzungen vorerst +-10
US_limit=ones(2,1)*10;

% Bewegungsvorgabe

jointcoord=input('Wollen Sie Start und Zielpunkt in Gelenkkoordinaten angeben, bitte eine 1 eingeben, sonst kart. Koordinaten: ')

Bahnart=input('Geben Sie die Bahnart an: Linearbahn: 1 eingeben, sonst PTP-Bahn: ')

% Bewegungsvorgabe

bahnvorgabe=0;   % Startwert, Ist Bewegungsvorgabe=0, dann ist die Bewegungsvorgabe nicht vollstndig oder Arbeitsraum verletzt

while bahnvorgabe==0
    
    if jointcoord==1
        disp('Bitte beachten Sie die Gelenkanschlge, q1 in m, q2 in rad:')
        qmin_max_1=['minimaler Wert q1: ',num2str(q1_min), ', maximaler Wert q1: ',num2str(q1_max) ];
        disp(qmin_max_1)
        qmin_max_2=['minimaler Wert q2: ',num2str(q2_min), ', maximaler Wert q2: ',num2str(q2_max) ];
        disp(qmin_max_2)
        
        q1_St=input('Startwert q1 bitte in m eingeben: ')
        q2_St=input('Startwert q2 bitte in rad angeben: ')
        q1_Z=input('Zielwert q1 bitte in m eingeben: ')
        q2_Z=input('Zielwert q2 bitte in rad angeben: ')
        
              
        % V_Trafo bei Vorgabe in Gelenkkoordinaten
        q_St=[q1_St; q2_St];             
        q_Z=[q1_Z; q2_Z]; 
        %[p_St]=VTRAFO_RT(q_St);
        [p_St,qp_St]=VTRAFO_TR_gesamt(q_St, [0;0],a2);
        x_St=p_St(1,1);
        z_St=p_St(3,1);
        [p_Z, qp_St]=VTRAFO_TR_gesamt(q_Z, [0;0],a2);
        x_Z=p_Z(1,1);
        z_Z=p_Z(3,1);
    else
        % Vorgabe: Start- und Zielpunkt in kartesischen Koordinaten
           
       disp('Bitte beachten Sie: Start- und Zielstellung mssen im zulssigen Bereich liegen')
        
        x_St=input('Startwert x-Koordinate in m eingeben: ')
        z_St=input('Startwert z-Koordinate in m eingeben: ')
        x_Z=input('Zielwert x-Koordinate in m eingeben: ')
        z_Z=input('Zielwert z-Koordinate in m eingeben: ')
        p_St=[x_St;0; z_St];
        p_Z=[x_Z;0;z_Z];
        [q_St,qp_St] = RTRAFO_TR_ges(p_St,zeros(3,1),a2,q_min,q_max);
    
       % disp('q_St nach Aufruf RTRAFO mit p_St')
        %q_St
        
        [q_Z,qp_Z] = RTRAFO_TR_ges(p_Z,zeros(3,1),a2,q_min,q_max);
     
    end
    
    % Prfung, ob Start- und Zielpunkt im Bewegungsbereich bzw. bei Fahren einer Linearbahn der Bewegungsbereich verlassen wird
    Pruef_Bahn_TR;
   
    
end
 

 
% Eingabe der Geschwindigkeits- und Beschleunigungswerte  und Bahnberechnung  
        
if Bahnart==1
    % hier Linearbahn
    vp=input('Bitte geben Sie die gewnschte Geschwindigkeit fr eine Rampenbahn in m/sec ein: ')
    bp=input('Bitte geben Sie die gewnschte Beschleunigung  fr eine Rampenbahn in m/sec ein: ')
    nachlauf=input('Bitte Nachlaufzeit in Prozent der Soll-Laufzeit angeben: ')
    nachlauf=nachlauf/100; 
        [psoll,v_bahn_soll,b_bahn,v_corr,b_corr,se,tb,tv,te,korr_msg] = Lin_bahn3D(p_St,p_Z,vp,bp,T_Ipo,1);
   % Eine Nachlaufzeit einfgen (am Ende Sollwert psoll belassen, v_bahn zu
   % 0 setzen 
   % nachlauf=0.15; 15% Nachlaufzeit
   [psoll, v_bahn_soll]=Nachlaufzeit(psoll, v_bahn_soll, nachlauf);
 
   [qsoll, qpsoll]=RTRAFO_TR_ges(psoll,v_bahn_soll,a2,q_min,q_max);
 
 % disp('Nach Aufruf von RTRAFO fr die ganze Linearbahn')
  % qsoll
  % qpsoll
  
   
else
    % hier PTP-Bahn
    vm1=input('Bitte geben Sie die gewnschte Geschwindigkeit fr eine Rampenbahn von Gelenk 1 in m/sec ein: ')
    bm1=input('Bitte geben Sie die gewnschte Beschleunigung  fr eine Rampenbahn von Gelenk 1 in m/sec ein: ') 
    vm2=input('Bitte geben Sie die gewnschte Geschwindigkeit fr eine Rampenbahn von Gelenk 2 in rad/sec ein: ')
    bm2=input('Bitte geben Sie die gewnschte Beschleunigung  fr eine Rampenbahn von Gelenk 2 in rad/sec ein: ')
    
   % vm1=1
   % bm1=4
   % vm2=pi/2
   % bm2=pi
    
     nachlauf=input('Bitte Nachlaufzeit in Prozent der Soll-Laufzeit angeben: ')
     nachlauf=nachlauf/100; 
    vm=[vm1;vm2];
    bm=[bm1;bm2];
    [qsoll,status,qpsoll,qpp_ptp] = ptp_2G(q_St,q_Z,vm,bm,0,1,T_Ipo); % es wird nur asynchrone Rampenbahn verwendet
     % Eine Nachlaufzeit einfgen (am Ende Sollwert psoll belassen, v_bahn zu
   % 0 setzen 
    %nachlauf=0.15; 15% Nachlaufzeit
   [qsoll, qpsoll]=Nachlaufzeit(qsoll, qpsoll, nachlauf);
    [psoll, v_bahn_soll]=VTRAFO_TR_gesamt(qsoll, qpsoll,a2); % VTRAFO 
end


% Definition der Regelungsstruktur (1: P-PI-Kaskade, 2. PT2-Verhalten modellbasiert, 3: P-PI-Kaskade modellbasiert 
% 4: P-Redus_modellbasiert, % 5. Redus_P_modellbasiert

Regelungsstruktur=0; % Startwert: keine gltige Reglerstruktur ausgewhlt
abbruch=0; % Startwert: Istgren q1 und q2 verletzen nicht die Gelenkbeschrnkungen 


while Regelungsstruktur==0
    disp(' Vorgabe der Reglerstruktur')
text_reg='1:P-PI, 2:P-Redus, 3:Redus-P, 4:PT2 (modellbasiert), 5:P-PI (modellbasiert), 6:P-Redus (modellbasiert), 7:Redus-P (modellbasiert) ';

Regelungsstruktur=input(text_reg)
switch Regelungsstruktur 
    case 1
        Eingabe_P_PI
   case 2
        Eingabe_P_Redus
   case 3
        Eingabe_Redus_P
    case 4
        Eingabe_mod_PT2
    case 5
        Eingabe_P_PI_mod
    case 6
        Eingabe_P_Redus_mod
    case 7
        Eingabe_Redus_P_mod
    otherwise
        disp(' Sie haben keine Reglerstruktur ausgewhlt, bitte auswhlen')
        Regelungsstruktur=0
end
end


Zweigelenk_sim; % Hauptprogramm: Regelungsaufruf, Simulation

% Ausgabe_Zweigelenkregelung
if abbruch==0
Ausgabe_Zweigelenkregelung;
end
