% Streckenparameter fr Programm Simulation_Zweigelenkregelung

% Parameter fr die Strecke einer Zweigelenkregelung
%  Siehe "Modellbildung und Regelung fr
% Industrieroboter II" (BSR04), Kap. 3.2.3, Abb. 3.7  
% W. Weber, Stand August 2023

l2=0.5;
a2=l2;  % hier direkte Angabe von a2 wg RTRAFO

eps_qp=0.005; % kleiner eps_qp wird als 0 betrachtet

mL=0; % Vorbesetzung
mL=input('Hier kann eine fr die Regelung unbekannte Lastmasse in kg angegeben werden(Massenmittelpunkt im TCP): ')
%h=input('h: Rotatorische Achse: 1 eingeben, translatorische Achse: 0
%eingeben: Ihre Eingabe: ')
%h=input('h: Rotatorische Achse: 1 eingeben, translatorische Achse: 0 eingeben: Ihre Eingabe: ')
h1=0;  % 1. Achse translatorisch
h2=1;  % 2. Achse rotatorisch

g=9.81;  % Gravitationskonstante
%g=input('g: Wert der Gravitationskonstante, z.B. 9.81 oder 10, kein Einfluss der Gravitation: g=0=, Ihre Eingabe: ')


%1. Streckenparameter Armteil 1/Gelenk 1 

%  Trgheitsmomente (Hauptachsenwerte von I_1) im Schwerpunkt Armteil 1 um Achsen von K1 
Ixx_1=0.2;
Iyy_1=0.1;
Izz_1=0.2;
I_1=[Ixx_1 0 0; 0 Iyy_1 0; 0 0 Izz_1];

s1=[0;0;0]; % Vektor vom Ursprung K1 zum Schwerpkt. AT1 in K1
p1=[0;0;0];    % Vektor vom Ursprung von K0 zum Ursprung von K1 in K1
m1=20; % Masse Armtei l1

%MRG0=0.05; % Haftreibungsschwelle Gelenk 1, hier Rotationsgelenk in Nm
MRG0=0;
FD1=4;    % Reibungskoeffizient der geschw.abhngigen Reibung im Gelenk, Einheit Nsec
% Parameter Motor
JA1=2.5e-4;  % Trgheitsmoment Motorwelle 
C1=1;      %  Motorkonstante in Nm/A

MR01=0; % Haftreibungsmoment(Schwelle) des Motors in Nm 
%MR01=0;
FM1=4e-5;  % Reibungskoeffizient der geschw.abhngigen Reibung des Motorankers, Einheit Nmsec/rad

KMI1=2;     % Messkonstante zwischen momentenbildendem Strom und Spannung in V/A: 





    %1. Streckenparameter Armteil 2/Gelenk 2 ohne Lastmasse

%  Trgheitsmomente (Hauptachsenwerte von I_2) im Schwerpunkt Armteil 1 um Achsen von K1 
Ixx_2=0.1;
Iyy_2=0.2;
Izz_2=0.2;
I_2=[Ixx_2 0 0; 0 Iyy_2 0; 0 0 Izz_2];

s2=[-0.2;0;0;]; % Vektor vom Ursprung K1 zum Schwerpkt. AT1 in K1
p2=[a2;0;0];    % Vektor vom Ursprung von K0 zum Ursprung von K1 in K1
m2=10; % Masse Armteil 2

FR02=0; % Haftreibungsschwelle Gelenk 2, hier Rotationsgelenk in N
FD2=1;    % Reibungskoeffizient der geschw.abhngigen Reibung im Gelenk, Einheit Nmsec/rad

% Parameter Motor
JA2=0.5e-4;  % Trgheitsmoment Motorwelle 
C2=0.8;      %  Motorkonstante in Nm/A

%MR02=0.09; % Haftreibungsmoment(Schwelle) des Motors in Nm 
MR02=0
FM2=8e-5;  % Reibungskoeffizient der geschw.abhngigen Reibung des Motorankers, Einheit Nmsec/rad

KMI2=5;     % Messkonstante zwischen momentenbildendem Strom und Spannung in V/A: 



% Getriebematrix
u1=400;  
u2=100;

SG=[u1 0; 0 u2];
TG=(inv(SG))';

%Matrizen fr die Streckenberechnung;
JA=[JA1 0; 0 JA2]; 
KM=[C1/KMI1 0; 0 C2/KMI2];
FD=[FD1 0; 0 FD2]; 
FM=[FM1 0; 0 FM2]; 
MR0=[MR01;MR02]; 
Haft_G0=[MRG0;FR02];
C=[C1 0; 0 C2];
