function [p_vek, vp_vek] = VTRAFO_TR_ges(q_vek, qp_vek,a2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   VTRAFO und Abbildung qp --> pp fr den TR-Roboter (siehe 
%  ausfhrliches Beispiel zu mc02_03 (Motion Control Master Mech)
%   
%
%   W. Weber: Oktober 2012
%
%   Eingabe: q_vek (2,n), : Zeitliche Serie derD.-H. Gelenkkoordinaten q1, q2 der  Gelenke 1 und 2
%   
%                
%   Ausgabe: p_vek, Vektor p_vek(2,n) mit den Komponenten x0, y0 in einer
%   Spalte
%   
%   
%  Lnge des Armteils 2: a2 in der Beschr.:a2=0.5!
%   
%   
%   W. Weber, letzte nderung Oktober 2012
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%


p_vek(1,:)=a2*sin(q_vek(2,:)-pi/2);
% px=a2*cos(q2-90);
p_vek(2,:)=0;
% py=0

p_vek(3,:)= q_vek(1,:) + a2*cos(q_vek(2,:)-pi/2);
%pz=q1+a2*cos(q2-90)

vp_vek(1,:)=a2*cos(q_vek(2,:)-pi/2).* qp_vek(2,:);
vp_vek(2,:)=0;
vp_vek(3,:)=qp_vek(1,:)-a2*sin(q_vek(2,:)-pi/2).*qp_vek(2,:); 










   

