% Simulation des Regelungsverhaltens
% Letzte nderung 29.09.23 von W. Weber, Einfhrung der Stellbegrenzung
% US_limit, berprfung, ob q_ist Gelenkanschlge verletzt.
%


dim_soll=size(qsoll);
anz_tick=dim_soll(2);   % Anzahl der Abtastschritte

qist=[qsoll(1,1);qsoll(2,1)]; % Startwert, zu Beginn ist qsoll=qist
qpist=[qpsoll(1,1);qpsoll(2,1)]; % Startwert
US=[0;0];
US_alt=zeros(2,1);
r0_alt=zeros(2,1);  %Startwert Stellgre Geschw.regler modellbas. P-PI Kaskade 
e_alt=zeros(2,1);
ev_alt=zeros(2,1); % Regelfehler Geschwindigkeitsregelkreis des vorhergehenden Zyklusl
Iv_alt=zeros(2,1); % Integral des Geschwindigkeitsregelfehlers (fr P-Redus Kaskaden)
Iq_alt=zeros(2,1); % Integral des Lageregelfehlers (fr Redus-P Kaskaden)

for i1=1:anz_tick-1  % 1. Hauptschleife
    qsoll_akt=qsoll(:,i1);
    %qsoll_akt=[qsoll(1,i1);qsoll(2,i1)]; % aktueller Sollwert
    qist_akt=[qist(1,i1);qist(2,i1)];
    qpist_akt=qpist(:,i1);
    qpsoll_akt=qpsoll(:,i1);
    switch Regelungsstruktur 
    case 1
        [US_akt,ev]=P_PI(KL, KVor, c1, c2, ev_alt,US_alt, US_limit,qsoll_akt, qist_akt, qpsoll_akt, qpist_akt);
        US_alt=US_akt;
        ev_alt=ev;
    case 2
        [US_akt,ev,Iv_akt]=P_Redus(TA,KL, KVor,alpha, beta, KI, ev_alt,Iv_alt, US_limit,qsoll_akt, qist_akt, qpsoll_akt, qpist_akt);
        Iv_alt=Iv_akt;
        ev_alt=ev;
    case 3
        [US_akt,e,Iq_akt]=Redus_P(TA, beta, alpha, KI, KP, e_alt,Iq_alt,US_limit, qsoll_akt, qist_akt, qpsoll_akt, qpist_akt); 
        
        Iq_alt=Iq_akt;
        e_alt=e;
     case 4
        [US_akt]=Mod_PT2(A0, A1, US_alt,US_limit, qsoll_akt, qist_akt, qpsoll_akt, qpist_akt);
     case 5
        [US_akt,ev,r0]=Mod_P_PI(KL, KVor, c1, c2, ev_alt,US_alt,US_limit, r0_alt, qsoll_akt, qist_akt, qpsoll_akt, qpist_akt);
         r0_alt=r0;
         ev_alt=ev;
         US_alt=US_akt; 
      case 6
        [US_akt,ev,Iv_akt,r0]=Mod_P_Redus(TA, KL, KVor, alpha, beta, KI, ev_alt,US_alt,US_limit, Iv_alt, qsoll_akt, qist_akt, qpsoll_akt, qpist_akt); 
        %r0_alt=r0;
        Iv_alt=Iv_akt;
        US_alt=US_akt;
        ev_alt=ev;
      case 7
       
       [US_akt,e,Iq_akt]=Mod_Redus_P(TA, beta, alpha, KI, KP, e_alt,US_alt,US_limit,Iq_alt,qsoll_akt, qist_akt, qpsoll_akt, qpist_akt)
        
        e_alt=e;
        Iq_alt=Iq_akt
        US_alt=US_akt; 
    end
    % Berechnung der neuen Werte fr q und qp
    [qist_neu, qpist_neu]=RK2_eig(US_akt,qist_akt,qpist_akt);
    % berprfung, ob qist_neu im Bewegungsbereich liegt
    
    if qist_neu(1,1) < q_min(1,1) |  qist_neu(1,1)> q_max(1,1) 
     disp('Gelenkbeschrnkung des Ist-Wertes von q1 verletzt')
    end
    if qist_neu(2,1) < q_min(2,1) |  qist_neu(2,1)> q_max(2,1)
        disp('Gelenkbeschrnkung des Ist-Wertes von q2 verletzt')
    end
    
    %if qist_neu(1,1) < q_min(1,1) |  qist_neu(1,1)> q_max(1,1) | qist_neu(2,1) < q_min(2,1) |  qist_neu(2,1)> q_max(2,1) 
    %    disp('Gelenkbeschrnkungen einer Istkoordinate verletzt')
   %     %abbruch=1;
        %break
   % end
    
    qist=[qist qist_neu];   
    qpist=[qpist qpist_neu];
    US=[US US_akt];
end

% Durch VTRAFo werden die entsprechenden kartesischen Ist-Werte gebildet
[pist, v_bahn_ist]=VTRAFO_TR_gesamt(qist, qpist,a2); % VTRAFO 